# Learn C Programming - Second Edition

<a href="https://www.packtpub.com/product/learn-c-programming-second-edition/9781801078450?utm_source=github&utm_medium=repository&utm_campaign=9781801078450"><img src="https://static.packt-cdn.com/products/9781801078450/cover/smaller" alt="Learn C Programming - Second Edition" height="256px" align="right"></a>

This is the code repository for [Learn C Programming - Second Edition](https://www.packtpub.com/product/learn-c-programming-second-edition/9781801078450?utm_source=github&utm_medium=repository&utm_campaign=9781801078450), published by Packt.

**A beginner's guide to learning the most powerful and general-purpose programming language with ease**

## What is this book about?
The foundation for many modern programming languages such as C++, C#, JavaScript, and Go, C is widely used as a system programming language as well as for embedded systems and high-performance computing. With this book, you'll be able to get up to speed with C in no time. 

This book covers the following exciting features:
* Implement fundamental programming concepts through C programs
* Understand the importance of creating complex data types and the functions to manipulate them
* Develop good coding practices and learn to write clean code
* Validate your programs before developing them further
* Use the C Standard Library functions and understand why it is advantageous
* Build and run a multi-file program with Make
* Get an overview of how C has changed since its introduction and where it is going

If you feel this book is for you, get your [copy](https://www.amazon.com/dp/1801078459) today!

<a href="https://www.packtpub.com/?utm_source=github&utm_medium=banner&utm_campaign=GitHubBanner"><img src="https://raw.githubusercontent.com/PacktPublishing/GitHub/master/GitHub.png" 
alt="https://www.packtpub.com/" border="5" /></a>

## Instructions and Navigations
All of the code is organized into folders. For example, Chapter02.

The code will look like the following:
```
html, body, #map {
 height: 100%;
 margin: 0;
 padding: 0
}
```

**Following is what you need for this book:**
If you're an absolute beginner who has basic familiarity with operating a computer, this book will help you learn the most fundamental concepts and practices that you need to know to become a successful C programmer. If you're an experienced programmer, you'll find the full range of C syntax as well as common C idioms covered in the book useful.

With the following software and hardware list you can run all code files present in the book (Chapter 1-27).
### Software and Hardware List
| Chapter | Software required | OS required |
| -------- | ------------------------------------ | ----------------------------------- |
| 1-27 | GCC | Windows, Mac OS X, and Linux (Any) |

We also provide a PDF file that has color images of the screenshots/diagrams used in this book. [Click here to download it](https://packt.link/uDSeu).

### Related products
* Expert C++ [[Packt]](https://www.packt.com/product/programming/b13597-expert-c/?utm_source=github&utm_medium=repository&utm_campaign=9781801073240) [[Amazon]](https://www.amazon.com/dp/1838552650)

* C++20 STL Cookbook [[Packt]](https://www.packt.com/product/programming/b18267-c-20-stl-cookbook/?utm_source=github&utm_medium=repository&utm_campaign=9781800568754) [[Amazon]](https://www.amazon.com/dp/1803248718)

## Get to Know the Author
**Jeff Szuhay**
is the principal developer at QuarterTil2 which specializes in graphics-rich software chronographs for desktop environments. In his software career of over 35 years, he has engaged in a full range of development activities from systems analysis and systems performance tuning to application design, from initial development through full testing and final delivery. Throughout that time, he has taught computer applications and programming languages at various educational levels from elementary school students to university students, as well as developed and presented professional, on-site training.
